Subject: Re: bug#21380: 25.0.50; GTK-induced segfault when scheduling timer from window-configuration-change-hook

From: martin rudalics <[email-masked]>
Date: Sun, 30 Aug 2015 20:10:28 +0200

> I think the problem is the call to do_pending_window_change in
 > xg_frame_resized in gtkutil.c: the commit message (commit 3477e27021db)
 > says:
 >
 > Author:     Martin Rudalics <[email-masked]>
 > AuthorDate: Sun Jul 27 15:21:30 2014 +0200
 > Commit:     Martin Rudalics <[email-masked]>
 > CommitDate: Sun Jul 27 15:21:30 2014 +0200
 >
 >      Complete pixelwise frame/window resizing, add horizontal scrollbar
 > support.
 >      [...]
 >      * gtkutil.c (xg_frame_resized): Don't call
 >      do_pending_window_change.
 >
 > but the diff is:
 >
 > @@ -883,6 +884,8 @@ xg_frame_resized (struct frame *f, int pixelwidth, int
 > pixelheight)
 >         change_frame_size (f, width, height, 0, 1, 0, 1);
 >         SET_FRAME_GARBAGED (f);
 >         cancel_mouse_face (f);
 > +
 > +      do_pending_window_change (0);
 >       }
 >   }

Remarkable.  I don't remember why I added them.  And obviously I have no
idea why I wrote the ChangeLog entry in reverse.  Just as if I read diff
output in the wrong direction.

In my understanding the do_pending_window_change call is not needed and
usually should be a noop.  But I have no idea why this particular call
of do_pending_window_change would run ‘window-configuration-change-hook’
and subsequently cause the havoc you describe.  The last
change_frame_size should have just happened three lines before.

 > And my current understanding is this bug would not occur if that call were
 > removed. The same issue applies to the change to x_set_window_size, but I'm
 > not certain about removing either call.

Maybe.  But the cause of the SEGFAULT must be elsewhere.  I have no
idea how

4. make_list interrupted by QUIT

could happen "while the temporary copy is being created" when
timer_check has set Vinhibit_quit to t.

martin